/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <windows.h>

#include "string.h"

class CConfig
{
private:

	plexdata::string::CString m_strFileName;

public:

	static LPCTSTR SEC_GENERAL;
	static LPCTSTR ITEM_COUNT;
	static LPCTSTR SHORT_PATH;
	static LPCTSTR ICON_SIZE;
	static LPCTSTR SYS_FONT;

	static LPCTSTR SEC_FONT;
	static LPCTSTR FONT_NAME;
	static LPCTSTR FONT_SIZE;
	static LPCTSTR FONT_BOLD;
	static LPCTSTR FONT_ITALIC;
	static LPCTSTR FONT_UNDERLINE;

	static LPCTSTR SEC_ITEM;
	static LPCTSTR ITEM_NAME;
	static LPCTSTR ITEM_EXECUTABLE;
	static LPCTSTR ITEM_SHOWCOMMAND;
	static LPCTSTR ITEM_PARAMETERS;
	static LPCTSTR ITEM_WORKING;
	static LPCTSTR ITEM_DESCRIPTION;
	static LPCTSTR ITEM_ICONFILE;
	static LPCTSTR ITEM_ICONINDEX;

public:

	CConfig();

	CConfig( LPCTSTR szFileName );

	virtual ~CConfig();

	bool SetFileName( LPCTSTR szFileName=NULL );

	LPCTSTR GetFileName();

	bool GetString( LPCTSTR szSection, LPCTSTR szVariable, LPTSTR pValue, size_t nValue );

	bool GetBoolean( LPCTSTR szSection, LPCTSTR szVariable, bool* pValue );

	bool GetSigned( LPCTSTR szSection, LPCTSTR szVariable, long* pValue );

	bool GetUnsigned( LPCTSTR szSection, LPCTSTR szVariable, unsigned long* pValue );

	bool SetString( LPCTSTR szSection, LPCTSTR szVariable, LPCTSTR szValue, bool bQuoted=false );

	bool SetBoolean( LPCTSTR szSection, LPCTSTR szVariable, bool bValue, bool bAsString=true );

	bool SetSigned( LPCTSTR szSection, LPCTSTR szVariable, long lValue );

	bool SetUnsigned( LPCTSTR szSection, LPCTSTR szVariable, unsigned long dwValue );
};

// EOF