/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <windows.h>
#include <commctrl.h>

class CListViewMoveItemsWrapper
{

private:
	
	HWND m_hListView;

public:

	CListViewMoveItemsWrapper( HWND hListView );
	virtual ~CListViewMoveItemsWrapper();

public:

	inline HWND ListView()
	{
		return this->m_hListView;
	}

	inline HWND GetHeaderControl()
	{
		return ListView_GetHeader( this->m_hListView );
	}

	inline int GetColumnsCount()
	{
		return Header_GetItemCount( this->GetHeaderControl() );
	}

public:

	UINT GetItemState( int iItem, UINT uMask );

	// ATTENTION: This member function allocates memory for structure member pItem->pszText
	//            if uMask includes LVIF_TEXT flag. You have to free this memory by using 
	//            delete[] pItem->pszText!
	bool GetItem( UINT uMask, UINT uStateMask, int iItem, int iSubItem, LPLVITEM pItem );

	// ATTENTION: This member function allocates memory for return value szText. 
	//            You have to free this memory by using delete[] szText!
	bool GetItemText( int iItem, int iSubItem, LPTSTR& szText, int& nText );

	void SetItemText( int iItem, int iSubItem, LPCTSTR szText );

	void SwapItems( int iItem1, int iItem2 );

	void MoveSelectedItemsUp();

	void MoveSelectedItemsDown();

	void MoveSelectedItems( bool bDown );
};
