/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <windows.h>
#include "record.h"

/******************************************************************************
** CManipulateDialog
*******************************************************************************/

class CManipulateDialog
{
public:

	CManipulateDialog();

	virtual ~CManipulateDialog();

public:

	INT_PTR Show( HINSTANCE hInstance, HWND hParent );

private:

	static INT_PTR CALLBACK DialogProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	void OnInitDialog( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnSysCommand( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnCommand( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnNotify( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnDropFiles( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnDestroy( HWND hWnd, WPARAM wParam, LPARAM lParam );
	
private:

	void InsertItemAt( HWND hList, CRecord* pData, DWORD dwIndex );

	void SaveData( HWND hList );

	void SaveGlobalData( HWND hWnd );

	void MoveItem( HWND hList, bool bDown );

	int FirstSelected( HWND hList );

	int LastSelected( HWND hList );

	bool IsListBegin( HWND hList );

	bool IsListEnd( HWND hList );

private:

	bool m_bOptionsChanged;

private: // List view subclassing stuff.

	static LRESULT CALLBACK LVSubWndProc( HWND hList, UINT uMsg, WPARAM wParam, LPARAM lParam );

	static LONG_PTR m_pLVWndProc; // Should not be a member variable!
};

// EOF

