/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <windows.h>
#include "string.h"

/******************************************************************************
** COptionDialog
*******************************************************************************/

class COptionDialog
{
public:

	COptionDialog();

	virtual ~COptionDialog();

public:

	INT_PTR Show( HINSTANCE hInstance, HWND hParent );

private:

	static INT_PTR CALLBACK DialogProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	void OnInitDialog( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnCommand( HWND hWnd, WPARAM wParam, LPARAM lParam );

private:

	static int CALLBACK EnumFontFamExProc( ENUMLOGFONTEX* pEnumLF, NEWTEXTMETRICEX* pMetric, DWORD dwType, LPARAM lParam );

	void SaveData( HWND hWnd );

	void EnableFontGroup( HWND hWnd, bool bEnable );

	int GetFontSize( HWND hWnd, HDC hDC=NULL );

	void GetFontName( HWND hWnd, TCHAR* szName, int nCount );

	void UpdateFontSampleText( HWND hWnd );

	void ComboEditChangeHelper( HWND hWnd );

private:

	HFONT m_hSampleFont;
};

// EOF