/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <windows.h>
#include "record.h"
#include "string.h"

/******************************************************************************
** CShowTypeData
*******************************************************************************/

class CShowTypeData
{
private:

	typedef struct
	{
		DWORD   value;
		LPCTSTR label;
	} ENTRY;

	static ENTRY LIST[];

	CShowTypeData();

public:

	~CShowTypeData();

public:

	static DWORD Count();

	static DWORD IndexToValue( DWORD dwIndex );

	static DWORD ValueToIndex( DWORD dwValue );

	static LPCTSTR IndexToString( DWORD dwIndex );

	static LPCTSTR ValueToString( DWORD dwValue );

};

/******************************************************************************
** CRegisterDialog
*******************************************************************************/

class CRegisterDialog
{
public:

	CRegisterDialog();

	virtual ~CRegisterDialog();

public:

	INT_PTR Show
		( HINSTANCE hInstance
		, HWND      hParent
		, CRecord*  pData=NULL
		, LPCTSTR   szTitle=NULL 
		);
	
	CRecord* GetData();

private:

	static INT_PTR CALLBACK DialogProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	void OnInitDialog( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnCommand( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnScroll( HWND hWnd, WPARAM wParam, LPARAM lParam );

	void OnDestroy( HWND hWnd, WPARAM wParam, LPARAM lParam );

private:

	void LoadData( HWND hWnd );

	void SaveData( HWND hWnd );

	void LoadIcon( HWND hParent, const TCHAR* szResource, int nIndex );

	void UpdateIcon( HWND hParent, const TCHAR* szResource, int nIndex );

	void EnableComponents( HWND hWnd, bool bEnable );

private:

	CRecord m_cRecord;
	plexdata::string::CString m_szTitle;
};

// EOF