/*
 * Copyright (C) 2009  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include <crtdbg.h>

#include "resource.h"
#include "msghelp.h"
#include "config.h"
#include "record.h"
#include "string.h"
#include "splitpath.h"

extern HICON          g_hIcon;
extern HWND           g_hWindow;
extern HINSTANCE      g_hInstance;
extern BOOL           g_bTrayEnabled;
extern NOTIFYICONDATA g_sTrayData;
extern bool           g_bLargeIcons;
extern bool           g_bShortPath;
extern bool           g_bSystemFont;
extern LOGFONT        g_lfMenuFont;

extern class CConfig g_Config;
extern class plexdata::string::CString g_strModule;

#define WM_TRAYNOTIFY  ( WM_USER + 100  )
#define WM_EDIT_MENU   ( WM_USER + 1000 )
#define WM_ABOUT_MENU  ( WM_USER + 1001 )
#define WM_PARAMS_MENU ( WM_USER + 1002 )
#define WM_REMOVE_MENU ( WM_USER + 1003 )
#define WM_EXIT_MENU   ( WM_USER + 1004 )

void ShowHelp( HWND hParent );

void CloseHelp();

bool ResolveData( HWND hWnd, plexdata::string::CString strFilename, CRecord& theRecord );

bool ExpandEnvironmentPath( plexdata::string::CString strSource, plexdata::string::CString& strExpand );

bool GetRegIconFile( plexdata::string::CString strExtension, plexdata::string::CString& strIconFile, int& nIconIndex );

bool GetRegFileType( LPCTSTR szFile, plexdata::string::CString& strType );

// EOF